Program PCB2MBBS;

Uses CRT, DOS;

{$I RECORDS.PAS}

Function Str2Int (Str: String): LongInt;
Var
	i: Word;
	Temp: LongInt;
Begin
  Val(Str, Temp, i);
  If i = 0 Then
    Str2Int := Temp
  Else
    Str2Int := 0;
End;

Function LongDate (DStr: String) : LongInt;
{MM/DD/YY to LongInt}
Var
	DT     : DateTime;
	DosDate: LongInt;

Begin
	DT.Year := Str2Int(Copy(DStr, 7, 2));

	If Dt.Year < 80 Then
    Inc(DT.Year, 2000)
	Else
		Inc(DT.Year, 1900);

  DT.Month := Str2Int(Copy(DStr, 1, 2));
  DT.Day   := Str2Int(Copy(DStr, 4, 2));
  DT.Hour  := 0;
  DT.Min   := 0;
  DT.Sec   := 0;

  PackTime(DT, DosDate);
  LongDate := DosDate;
End;

Var
	inFile   : Text;
	desFile  : File;
	FDirFile : File of FDirRec;
	FDir     : FDirRec;
	Desc     : Array[1..99] of String[45];
	Str      : String;
	A        : Byte;
	Total    : Integer;

  D: DirStr;
  N: NameStr;
  E: ExtStr;

Begin
	WriteLn;
	WriteLn ('PCB2MBBS.EXE: PCBoard to Mystic BBS File Base Converter.');
	WriteLn ('Copyright (C) 1998-1999 By James Coyle.  All Rights Reserved.');
	WriteLn;
	TextAttr := 12;
	WriteLn ('For Mystic BBS Version ', Version, ' and compatibles ONLY!');
	TextAttr := 7;
	WriteLn;

	If ParamCount <> 2 Then Begin
		WriteLn ('Usage: <PCBoard File>  <Mystic BBS File>');
		Halt(1);
	End;

	Assign (inFile, ParamStr(1));
	{$I-} Reset(inFile); {$I+}
	If IoResult <> 0 Then Begin
		WriteLn (^G'ERROR: PCBoard file listing (', ParamStr(1), ') not found.');
		Halt(1);
	End;

	FSplit (ParamStr(2), D, N, E);

	Assign (FDirFile, D + N + '.DIR');
	{$I-} Reset (FDirFile); {$I+}
	If IoResult <> 0 Then ReWrite (FDirFile);

	Assign (desFile, D + N + '.DES');
	{$I-} Reset (desFile, 1); {$I+}
	If IoResult <> 0 Then ReWrite (desFile, 1);

	Total := 0;

	Write ('Processing: ');

	While Not Eof(inFile) Do Begin
		If (Str[26] = '-') and (Str[29] = '-') Then Begin

			Inc (Total);
			GotoXY (13, WhereY);
			Write (Total, ' files ... ');

  		FDir.FileName := Copy(Str, 1, Pos(' ', Str) - 1);
			FDir.Size     := Str2Int(Copy(Str, 13, 9));
			FDir.DateTime := LongDate(Copy(Str, 24, 8));
			FDir.Uploader := 'Mystic BBS';
			FDir.Flags    := [];
			FDir.DLs      := 0;
			FDir.Lines    := 1;
			FDir.Pointer  := FileSize(desFile);

			Desc[1]  := Copy(Str, 34, Length(Str));
			Repeat
				ReadLn (inFile, Str);
				If Str[32] = '|' Then Begin
					Inc (FDir.Lines);
					Desc[FDir.Lines] := Copy(Str, 34, Length(Str));
				End;
			Until (Str[32] <> '|') or Eof(inFile);

      Write (FDirFile, FDir);
			Seek  (desFile, FDir.Pointer);
			For A := 1 to FDir.Lines Do Begin
				BlockWrite (desFile, Desc[A][0], 1);
				BlockWrite (desFile, Desc[A][1], Ord(Desc[A][0]));
			End;
		End Else
			If Not Eof(inFile) Then ReadLn (inFile, Str);
	End;

	Close (inFile);
	Close (FDirFile);
	Close (desFile);

	WriteLn ('DONE.');
End.